package com.sf.payment.domain;

import apijson.NotNull;
import lombok.*;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * 华为验证购买tokenDTO
 *
 * @author zk
 */
@Getter
@Setter
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class HuaweiPurchasesVerifyDTO implements Serializable {



    /**
     * 商品类型。
     * •	0：消耗型商品
     * •	1：非消耗型商品
     * •	2：自动续期订阅商品
     */
    @NotNull
    private Integer type;

    /**
     * 包含订单信息的JWS格式数据。
     * 可参见对返回结果验签
     * 解码验签获取相关购买数据的JSON字符串，
     * 其包含的参数请参见PurchaseOrderPayload。
     */
    private String jwsPurchaseOrder;

    /**
     * 包含订阅状态信息的
     * JWS格式数据。
     * 可参见对返回结果验签
     * 解码验签获取相关订阅状态
     * 信息的JSON字符串，
     * 其包含的参数请参见
     * SubGroupStatusPayload。
     */
    private String jwsSubscriptionStatus;



}
