package com.sf.service.gateway.mapper;

import com.sf.service.gateway.domain.GatewayRoute;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * 路由管理Mapper接口
 * 
 * @author 邹坤
 * @date 2024-04-22
 */
public interface GatewayRouteMapper 
{
    /**
     * 查询路由管理
     * 
     * @param id 路由管理主键
     * @return 路由管理
     */
    public GatewayRoute selectGatewayRouteById(Long id);

    /**
     * 查询路由管理列表
     * 
     * @param gatewayRoute 路由管理
     * @return 路由管理集合
     */
    public List<GatewayRoute> selectGatewayRouteList(GatewayRoute gatewayRoute);

    /**
     * 新增路由管理
     * 
     * @param gatewayRoute 路由管理
     * @return 结果
     */
    public int insertGatewayRoute(GatewayRoute gatewayRoute);

    /**
     * 修改路由管理
     * 
     * @param gatewayRoute 路由管理
     * @return 结果
     */
    public int updateGatewayRoute(GatewayRoute gatewayRoute);

    /**
     * 删除路由管理
     * 
     * @param id 路由管理主键
     * @return 结果
     */
    public int deleteGatewayRouteById(Long id);

    /**
     * 批量删除路由管理
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteGatewayRouteByIds(Long[] ids);

    List<GatewayRoute> selectGatewayRouteByIds(@Param("ids") Collection<Long> ids);
}
